unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Mask, Output, Spin, SMSCode, ActiveX;

type

  SWInfoRec = packed record
    Nazev: WideString;
    Verze: WideString;
    Vyrobce: WideString;
    Helpline: WideString;
  end;

  TfrmMain = class(TForm)
    pnlLogo: TPanel;
    ImgPortal: TImage;
    Label1: TLabel;
    Label2: TLabel;
    grpZP: TRadioGroup;
    Label3: TLabel;
    grpSluzba: TRadioGroup;
    Label4: TLabel;
    grpSoubory: TGroupBox;
    btnOdeslat: TButton;
    bntKonec1: TButton;
    grpParametry: TGroupBox;
    chbParametry: TCheckBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    edtZP_Cert_IDN: TEdit;
    edtZP_Cert_SN: TEdit;
    lbFiles: TListBox;
    Label5: TLabel;
    btnClearFileList: TButton;
    btnDelFileItem: TButton;
    btnAppendFileItem: TButton;
    OpenDlg: TOpenDialog;
    ceTimeOut: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    gbCert: TGroupBox;
    chbCertAuth: TCheckBox;
    gbSMS: TGroupBox;
    chbSMSAuth: TCheckBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    edtSMSLogin: TEdit;
    edtSMSCode: TEdit;
    btnGetSMSCode: TButton;
    chbVisual: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure bntKonec1Click(Sender: TObject);
    procedure btnOdeslatClick(Sender: TObject);
    procedure chbParametryClick(Sender: TObject);
    procedure btnClearFileListClick(Sender: TObject);
    procedure btnDelFileItemClick(Sender: TObject);
    procedure btnAppendFileItemClick(Sender: TObject);
    procedure lbFilesClick(Sender: TObject);
    procedure chbSMSAuthClick(Sender: TObject);
    procedure chbCertAuthClick(Sender: TObject);
    procedure btnGetSMSCodeClick(Sender: TObject);
  private
    { Private declarations }
    IgnoreChbEvent: Boolean;
    SWInfo: SWInfoRec;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

function DllPZP_Run(const ZP: WideString; var ZP_Cert_SN, ZP_Cert_IDN: WideString;
      const Sluzba, DataIn: WideString;
      TimeOut: Smallint; SWInfo: SWInfoRec;
      var ID_Podani: SYSINT; var Chyba, Varovani, DataOut,
      Debug_internal_warning, Debug_XML_vyzva,
      Debug_XML_odpoved: WideString): HResult; stdcall;
function DllPZP_SMSAuth(const ZP: WideString; var ZP_Cert_SN,
      ZP_Cert_IDN: WideString; const Jmeno, Heslo: WideString;
      TimeOut: Smallint; SWInfo: SWInfoRec;
      var ID_Podani: SYSINT; var Chyba, Varovani,
      DataOut, Debug_internal_warning, Debug_XML_vyzva,
      Debug_XML_odpoved: WideString): HResult; stdcall;
function DllPZP_SMSRun(const ZP: WideString; var ZP_Cert_SN,
      ZP_Cert_IDN: WideString; const Sluzba, DataIn, Jmeno,
      SMSKod: WideString;
      TimeOut: Smallint; SWInfo: SWInfoRec;
      var ID_Podani: SYSINT;
      var Chyba, Varovani, DataOut, Debug_internal_warning,
      Debug_XML_vyzva, Debug_XML_odpoved: WideString): HResult; stdcall;

function DllPZP_RunNonVis(const ZP: WideString; var ZP_Cert_SN, ZP_Cert_IDN: WideString;
      const Sluzba, DataIn: WideString;
      TimeOut: Smallint; SWInfo: SWInfoRec;
      var ID_Podani: SYSINT; var Chyba, Varovani, DataOut,
      Debug_internal_warning, Debug_XML_vyzva,
      Debug_XML_odpoved: WideString): HResult; stdcall;
function DllPZP_SMSAuthNonVis(const ZP: WideString; var ZP_Cert_SN,
      ZP_Cert_IDN: WideString; const Jmeno, Heslo: WideString;
      TimeOut: Smallint; SWInfo: SWInfoRec;
      var ID_Podani: SYSINT; var Chyba, Varovani,
      DataOut, Debug_internal_warning, Debug_XML_vyzva,
      Debug_XML_odpoved: WideString): HResult; stdcall;
function DllPZP_SMSRunNonVis(const ZP: WideString; var ZP_Cert_SN,
      ZP_Cert_IDN: WideString; const Sluzba, DataIn, Jmeno,
      SMSKod: WideString;
      TimeOut: Smallint; SWInfo: SWInfoRec;
      var ID_Podani: SYSINT;
      var Chyba, Varovani, DataOut, Debug_internal_warning,
      Debug_XML_vyzva, Debug_XML_odpoved: WideString): HResult; stdcall;
function DllPZP_SchrOper(const ZP: WideString; var ZP_Cert_SN,
      ZP_Cert_IDN: WideString; const Operace, Identifikatory, SMSJmeno,
      SMSKod: WideString;
      TimeOut: Smallint; SWInfo: SWInfoRec; NonVis: Smallint;
      var ID_Podani: SYSINT;
      var Chyba, Varovani, DataOut, Debug_internal_warning,
      Debug_XML_vyzva, Debug_XML_odpoved: WideString): HResult; stdcall;

implementation

{$R *.dfm}

function DllPZP_Run; external 'PortalZP.dll' name 'DllPZP_Run';
function DllPZP_SMSAuth; external 'PortalZP.dll' name 'DllPZP_SMSAuth';
function DllPZP_SMSRun; external 'PortalZP.dll' name 'DllPZP_SMSRun';
function DllPZP_RunNonVis; external 'PortalZP.dll' name 'DllPZP_RunNonVis';
function DllPZP_SMSAuthNonVis; external 'PortalZP.dll' name 'DllPZP_SMSAuthNonVis';
function DllPZP_SMSRunNonVis; external 'PortalZP.dll' name 'DllPZP_SMSRunNonVis';
function DllPZP_SchrOper; external 'PortalZP.dll' name 'DllPZP_SchrOper';

Const cZP:array[0..7] of WideString = ('CPZP','OZP','RBP','ZPS','VoZP','PZP','PILOT','PILOT-PZP');
Const cSluzba:array[0..14] of WideString = ('VYU','HOZ','PPPZ','VERPOJ','VERZZ','ORL','PRESMER','SCHRANKA','EXE_PO','EXE_FO','P2_IMPORT','NOVY_CERT','SCHRANKA_PODANI','BZD','HDN');

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  PnlLogo.Color:=ImgPortal.Picture.Bitmap.Canvas.Pixels[1,1];
  chbParametry.Checked:=false;
  chbParametryClick(nil);
  lbFilesClick(nil);
  chbSMSAuth.Checked:=true;
  chbSMSAuthClick(chbSMSAuth);
  SWInfo.Nazev:='PortalZP_Demo';
  SWInfo.Verze:='2.7.2.45';
  SWInfo.Vyrobce:='Asseco Central Europe, a.s.';
  SWInfo.Helpline:='pomoc@portalzp.cz';
end;

procedure TfrmMain.bntKonec1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.btnOdeslatClick(Sender: TObject);
Var ID_Podani:Integer;
    SMSLogin, SMSKod, ZP, ZP_Cert_SN, ZP_Cert_IDN, Sluzba, DataIn, Chyba, Varovani, DataOut, XML_IN, XML_OUT, InternalWarning: WideString;
    TimeOut:Smallint;
    frmOutput: TfrmOutput;
    Idx: Integer;

  procedure AddDataIn(AFileName:String);
  begin
    If FileExists(AFileName) then
    begin
      If DataIn<>'' then
        DataIn:=DataIn+'|';
      DataIn:=DataIn+AFileName;
    end;
  end;

begin
  if chbSMSAuth.Checked then
  begin
    SMSLogin:=edtSMSLogin.Text;
    if trim(SMSLogin)='' then
    begin
      Application.MessageBox('Vyplte, prosm, pihlaovac jmno (konto).', 'Upozornn', MB_OK or MB_ICONWARNING);
      exit;
    end;
    SMSKod:=edtSMSCode.Text;
    if trim(SMSKod)='' then
    begin
      Application.MessageBox('Vyplte, prosm, SMS kd, kter Vm byl zasln na mobiln telefon.', 'Upozornn', MB_OK or MB_ICONWARNING);
      exit;
    end;
  end else
  begin
    SMSLogin:='';
    SMSKod:='';
  end;
  // Vstupni data
  ZP:=cZP[grpZP.ItemIndex];
  Sluzba:=cSluzba[grpSluzba.ItemIndex];
  DataIn:='';
  For Idx:=0 to lbFiles.Count-1 do
    AddDataIn(lbFiles.Items.Strings[Idx]);
  if chbParametry.Checked then
  begin
    ZP_Cert_SN:=Trim(edtZP_Cert_SN.Text);
    ZP_Cert_IDN:=Trim(edtZP_Cert_IDN.Text);
    Timeout:=ceTimeOut.Value;
  end else
  begin
    ZP_Cert_SN:='';
    ZP_Cert_IDN:='';
    Timeout:=300;
  end;
  // Volani knihovny
  try
    if chbVisual.Checked then
    begin
      if chbSMSAuth.Checked then
        DllPZP_SMSRun(ZP, ZP_Cert_SN, ZP_Cert_IDN, Sluzba, DataIn, SMSLogin, SMSKod, Timeout, SWInfo, ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out)
      else
        DllPZP_Run(ZP, ZP_Cert_SN, ZP_Cert_IDN, Sluzba, DataIn, Timeout, SWInfo, ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out);
    end else
    begin
      if chbSMSAuth.Checked then
        DllPZP_SMSRunNonVis(ZP, ZP_Cert_SN, ZP_Cert_IDN, Sluzba, DataIn, SMSLogin, SMSKod, Timeout, SWInfo, ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out)
      else
        DllPZP_RunNonVis(ZP, ZP_Cert_SN, ZP_Cert_IDN, Sluzba, DataIn, Timeout, SWInfo, ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out);
    end;
    // Vystup
    edtZP_Cert_SN.Text:=ZP_Cert_SN;
    edtZP_Cert_IDN.Text:=ZP_Cert_IDN;
    frmOutput:= TfrmOutput.Create(Self);
    frmOutput.FillData(ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out);
    frmOutput.ShowModal;
    frmOutput.Free;
  except
    on e:exception do Application.MessageBox(PChar(e.Message), 'Chyba', MB_OK or MB_ICONERROR);
  end;
end;

procedure TfrmMain.chbParametryClick(Sender: TObject);
Var PomI:Integer;
begin
  grpParametry.Enabled:=chbParametry.Checked;
  For PomI:=0 to grpParametry.ControlCount-1 do
    grpParametry.Controls[PomI].Enabled:=chbParametry.Checked;
end;

procedure TfrmMain.btnClearFileListClick(Sender: TObject);
begin
  lbFiles.Clear;
  lbFilesClick(nil);
end;

procedure TfrmMain.btnDelFileItemClick(Sender: TObject);
var ItmIdx: Integer;
begin
  ItmIdx:=lbFiles.ItemIndex;
  if lbFiles.ItemIndex>-1 then
    lbFiles.Items.Delete(lbFiles.ItemIndex);
  Dec(ItmIdx);
  If (ItmIdx<0) and (lbFiles.Count>0) then
    ItmIdx:=0;
  lbFiles.ItemIndex:=ItmIdx;
  lbFilesClick(nil);
end;

procedure TfrmMain.btnAppendFileItemClick(Sender: TObject);
begin
  If OpenDlg.Execute then
  begin
    lbFiles.Items.Append(OpenDlg.FileName);
    lbFiles.ItemIndex:=lbFiles.Items.Count-1;
    lbFilesClick(nil);
  end;
end;

procedure TfrmMain.lbFilesClick(Sender: TObject);
begin
  btnDelFileItem.Enabled:=lbFiles.ItemIndex>-1;
  btnClearFileList.Enabled:=lbFiles.Count>0;
end;

procedure TfrmMain.chbSMSAuthClick(Sender: TObject);
Var PomI:Integer;
begin
  if Assigned(Sender) and IgnoreChbEvent then exit;
  try
    IgnoreChbEvent:=true;
    if Assigned(Sender) then
      chbSMSAuth.Checked:=true;
    gbSMS.Enabled:=chbSMSAuth.Checked;
    For PomI:=0 to gbSMS.ControlCount-1 do
      gbSMS.Controls[PomI].Enabled:=chbSMSAuth.Checked;
    if Assigned(Sender) then
    begin
      chbCertAuth.Checked:=not chbSMSAuth.Checked;
      chbCertAuthClick(nil);
    end;
  finally
    IgnoreChbEvent:=false;
  end;
end;

procedure TfrmMain.chbCertAuthClick(Sender: TObject);
Var PomI:Integer;
begin
  if Assigned(Sender) and IgnoreChbEvent then exit;
  try
    IgnoreChbEvent:=true;
    if Assigned(Sender) then
      chbCertAuth.Checked:=true;
    gbCert.Enabled:=chbCertAuth.Checked;
    For PomI:=0 to gbCert.ControlCount-1 do
      gbCert.Controls[PomI].Enabled:=chbCertAuth.Checked;
    if Assigned(Sender) then
    begin
      chbSMSAuth.Checked:=not chbCertAuth.Checked;
      chbSMSAuthClick(nil);
    end;
  finally
    IgnoreChbEvent:=false;
  end;
end;

procedure TfrmMain.btnGetSMSCodeClick(Sender: TObject);
Var ID_Podani:Integer;
    SMSLogin, SMSPass, ZP, ZP_Cert_SN, ZP_Cert_IDN, Chyba, Varovani, DataOut, XML_IN, XML_OUT, InternalWarning: WideString;
    TimeOut:Smallint;
    frmOutput: TfrmOutput;
    frmSMSCode: TfrmSMSCode;
begin
  SMSLogin:=trim(edtSMSLogin.Text);
  frmSMSCode:=TfrmSMSCode.Create(Self);
  frmSMSCode.edtSMSLogin.Text:=SMSLogin;
  if frmSMSCode.ShowModal<>mrOK then
  begin
    frmSMSCode.Free;
    exit;
  end;
  SMSLogin:=trim(frmSMSCode.edtSMSLogin.Text);
  edtSMSLogin.Text:=SMSLogin;
  SMSPass:=frmSMSCode.edtSMSPass.Text;
  frmSMSCode.Free;
  // Vstupni data
  ZP:=cZP[grpZP.ItemIndex];
  if chbParametry.Checked then
  begin
    ZP_Cert_SN:=Trim(edtZP_Cert_SN.Text);
    ZP_Cert_IDN:=Trim(edtZP_Cert_IDN.Text);
    Timeout:=ceTimeOut.Value;
  end else
  begin
    ZP_Cert_SN:='';
    ZP_Cert_IDN:='';
    Timeout:=300;
  end;
  // Volani knihovny
  try
    if chbVisual.checked then
      DllPZP_SMSAuth(ZP, ZP_Cert_SN, ZP_Cert_IDN, SMSLogin, SMSPass, Timeout, SWInfo, ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out)
    else
      DllPZP_SMSAuthNonVis(ZP, ZP_Cert_SN, ZP_Cert_IDN, SMSLogin, SMSPass, Timeout, SWInfo, ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out);
    // Vystup
    edtZP_Cert_SN.Text:=ZP_Cert_SN;
    edtZP_Cert_IDN.Text:=ZP_Cert_IDN;
    frmOutput:= TfrmOutput.Create(Self);
    frmOutput.FillData(ID_Podani, Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out);
    frmOutput.ShowModal;
    frmOutput.Free;
  except
    on e:exception do Application.MessageBox(PChar(e.Message), 'Chyba', MB_OK or MB_ICONERROR);
  end;
end;

end.
