unit Output;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw;

type
  TfrmOutput = class(TForm)
    Label1: TLabel;
    edtID_Podani: TEdit;
    Label2: TLabel;
    edtChyba: TEdit;
    Label3: TLabel;
    wbOutput: TWebBrowser;
    btnOK: TButton;
    Label4: TLabel;
    Label5: TLabel;
    MemoXMLIn: TMemo;
    memoXMLOut: TMemo;
    Label6: TLabel;
    memoVarovani: TMemo;
    memoInternalWarning: TMemo;
    Label7: TLabel;
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FillData(ID_Podani:Int64; Chyba, Varovani, DataOut, InternalWarning, XML_In, XML_Out:WideString);
  end;

implementation

{$R *.dfm}

uses mshtml, ActiveX;

{ TfrmOutput }

Function ConvertISOLatin2ToWin1250(InS:String):String;
Const InPage  = '̩خϫ';  //ISO-8859-2 (ISO Latin 2)
Const OutPage = '̊؎ύ';  //Windows 1250
Var PomI, Pozice:Integer;
    Ch:Char;
begin
  result:='';
  For PomI:=1 to length(InS) do
  begin
    Ch:=InS[PomI];
    Pozice:=Pos(Ch, InPage);
    If Pozice>0 then
      Ch:=OutPage[Pozice];
    result:=result+ch;
  end;
end;

procedure TfrmOutput.FillData(ID_Podani: Int64; Chyba, Varovani, DataOut, InternalWarning,
  XML_In, XML_Out: WideString);

procedure WBLoadHTML(WebBrowser: TWebBrowser; HTMLCode: string) ;
var
   SL: TStringList;
   MS: TMemoryStream;
   IsHTML:Boolean;
   UpperHTML:String;
begin
   WebBrowser.Navigate('about:blank') ;
   while WebBrowser.ReadyState < READYSTATE_INTERACTIVE do
    Application.ProcessMessages;
   If Trim(HTMLCode)='' then exit;
   // Ve je v Charset ISO-8859-2, pokud to ale nema HTML zahlavi
   // (chybove hlaseni, prekonvertuju na Windows 1250
   UpperHTML:=AnsiUpperCase(HTMLCode);
   IsHTML:=((Pos('<HTML>',UpperHTML)>0) or (Pos('<HTML ',UpperHTML)>0));
   IsHTML:=IsHTML and (Pos('CHARSET=',UpperHTML)>0);
   If not IsHTML then
     HTMLCode:=ConvertISOLatin2ToWin1250(HTMLCode);
   if Assigned(WebBrowser.Document) then
   begin
     sl := TStringList.Create;
     try
       ms := TMemoryStream.Create;
       try
         sl.Text := HTMLCode;
         sl.SaveToStream(ms) ;
         ms.Seek(0, 0) ;
         (WebBrowser.Document as IPersistStreamInit).Load(TStreamAdapter.Create(ms)) ;
       finally
         ms.Free;
       end;
     finally
       sl.Free;
     end;
   end;
end;

begin
  edtID_Podani.Text:=IntToStr(ID_Podani);
  edtChyba.Text:=Chyba;
  WBLoadHTML(wbOutput, DataOut);
  MemoXMLIn.Lines.Text:=XML_In;
  MemoXMLOut.Lines.Text:=XML_Out;
  MemoVarovani.Lines.Text:=Varovani;
  MemoInternalWarning.Lines.Text:=InternalWarning;
end;

procedure TfrmOutput.FormResize(Sender: TObject);
begin
  wbOutput.width:=Width-(wbOutput.Left*2);
end;

end.
